<template src="./template.html"></template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
@Component({})
export default class ManageAdminComponent extends Vue {
	@Prop()
	tab!: number;

	config = {
		page: 1,
		limit: 25,
		search: "",
	};
	totalPage = 0;
	page = 1;

	listAdmin = [];
	adminDetail = {};
	loadingTable = false;
	dialogViewDetail = false;

	mounted() {
		this.onGetListAdmin();
	}

	async onGetListAdmin() {
		try {
			this.loadingTable = true;
			const response = await this.$api.userAdmin.listAdmin(this.config);
			if (response?.data?.data) {
				const { total } = response.data;
				this.totalPage = Math.ceil(total / this.config.limit);
				this.listAdmin = response.data.data;
			}
		} catch (error) {
			apiErrorHandler(error, this);
		} finally {
			this.loadingTable = false;
		}
	}

	openDialogViewDetail(admin: any) {
		this.adminDetail = admin;
		this.dialogViewDetail = true;
	}

	onRedirectPage() {
		this.config.page = this.page;
		this.onGetListAdmin();
	}

	@Watch("config.page")
	changedPage() {
		this.onGetListAdmin();
	}

	@Watch("tab")
	changeTab(value: number) {
		if (value === 1) {
			this.onGetListAdmin();
		}
	}
}
</script>